/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.112 Revision 1.134
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.112 2011/12/13 21:44:22 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.134 2012/05/20 12:31:32 vapier Exp $
4 4
5# @ECLASS: autotools.eclass 5# @ECLASS: autotools.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts 8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass is for safely handling autotooled software packages that need to 10# This eclass is for safely handling autotooled software packages that need to
11# regenerate their build scripts. All functions will abort in case of errors. 11# regenerate their build scripts. All functions will abort in case of errors.
12 12
13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
13if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then 16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
14___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank" 17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
15 18
16inherit eutils libtool 19inherit libtool
17 20
18# @ECLASS-VARIABLE: WANT_AUTOCONF 21# @ECLASS-VARIABLE: WANT_AUTOCONF
19# @DESCRIPTION: 22# @DESCRIPTION:
20# The major version of autoconf your package needs 23# The major version of autoconf your package needs
21: ${WANT_AUTOCONF:=latest} 24: ${WANT_AUTOCONF:=latest}
32 35
33# @ECLASS-VARIABLE: _LATEST_AUTOMAKE 36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
34# @INTERNAL 37# @INTERNAL
35# @DESCRIPTION: 38# @DESCRIPTION:
36# CONSTANT! 39# CONSTANT!
37# The latest major version/slot of automake available on each arch. 40# The latest major version/slot of automake available on each arch. #312315
38# If a newer version is stable on any arch, and is NOT reflected in this list, 41# If a newer slot is stable on any arch, and is NOT reflected in this list,
39# then circular dependencies may arise during emerge @system bootstraps. 42# then circular dependencies may arise during emerge @system bootstraps.
40# Do NOT change this variable in your ebuilds! 43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
41_LATEST_AUTOMAKE='1.11' 46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
42 47
43_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
44_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
45if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
46 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
47 none) _automake_atom="" ;; # some packages don't require automake at all 52 # Even if the package doesn't use automake, we still need to depend
48 # if you change the "latest" version here, change also autotools_run_tool 53 # on it because we run aclocal to process m4 macros. This matches
49 # this MUST reflect the latest stable major version for each arch! 54 # the autoreconf tool, so this requirement is correct. #401605
55 none) ;;
56 latest)
57 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
58 if [[ ${EAPI:-0} != 0 ]] ; then
59 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
60 else
50 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;; 61 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
62 fi
63 ;;
51 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 64 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
52 esac 65 esac
53 export WANT_AUTOMAKE 66 export WANT_AUTOMAKE
54fi 67fi
55 68
56if [[ -n ${WANT_AUTOCONF} ]] ; then 69if [[ -n ${WANT_AUTOCONF} ]] ; then
57 case ${WANT_AUTOCONF} in 70 case ${WANT_AUTOCONF} in
58 none) _autoconf_atom="" ;; # some packages don't require autoconf at all 71 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
59 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 72 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
60 # if you change the latest version here, change also autotools_run_tool 73 # if you change the "latest" version here, change also autotools_env_setup
61 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;; 74 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
62 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;; 75 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
63 esac 76 esac
64 export WANT_AUTOCONF 77 export WANT_AUTOCONF
65fi 78fi
66 79
93# @DEFAULT_UNSET 106# @DEFAULT_UNSET
94# @DESCRIPTION: 107# @DESCRIPTION:
95# Additional options to pass to automake during 108# Additional options to pass to automake during
96# eautoreconf call. 109# eautoreconf call.
97 110
111# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
112# @DEFAULT_UNSET
113# @DESCRIPTION:
114# Don't run eautomake command if set to 'yes'; only used to workaround
115# broken packages. Generally you should, instead, fix the package to
116# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
117
98# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE 118# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
99# @DEFAULT_UNSET 119# @DEFAULT_UNSET
100# @DESCRIPTION: 120# @DESCRIPTION:
101# Don't run elibtoolize command if set to 'yes', 121# Don't run elibtoolize command if set to 'yes',
102# useful when elibtoolize needs to be ran with 122# useful when elibtoolize needs to be ran with
103# particular options 123# particular options
104 124
105# XXX: M4DIR should be deprecated
106# @ECLASS-VARIABLE: AT_M4DIR 125# @ECLASS-VARIABLE: AT_M4DIR
107# @DESCRIPTION: 126# @DESCRIPTION:
108# Additional director(y|ies) aclocal should search 127# Additional director(y|ies) aclocal should search
109: ${AT_M4DIR:=${M4DIR}} 128: ${AT_M4DIR:=}
129
130# @ECLASS-VARIABLE: AT_SYS_M4DIR
131# @INTERNAL
132# @DESCRIPTION:
133# For system integrators, a list of additional aclocal search paths.
134# This variable gets eval-ed, so you can use variables in the definition
135# that may not be valid until eautoreconf & friends are run.
136: ${AT_SYS_M4DIR:=}
110 137
111# @FUNCTION: eautoreconf 138# @FUNCTION: eautoreconf
112# @DESCRIPTION: 139# @DESCRIPTION:
113# This function mimes the behavior of autoreconf, but uses the different 140# This function mimes the behavior of autoreconf, but uses the different
114# eauto* functions to run the tools. It doesn't accept parameters, but 141# eauto* functions to run the tools. It doesn't accept parameters, but
115# the directory with include files can be specified with AT_M4DIR variable. 142# the directory with include files can be specified with AT_M4DIR variable.
116# 143#
117# Should do a full autoreconf - normally what most people will be interested in. 144# Should do a full autoreconf - normally what most people will be interested in.
118# Also should handle additional directories specified by AC_CONFIG_SUBDIRS. 145# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
119eautoreconf() { 146eautoreconf() {
120 local x auxdir g 147 local x g
121 148
122 if [[ -z ${AT_NO_RECURSIVE} ]]; then 149 if [[ -z ${AT_NO_RECURSIVE} ]]; then
123 # Take care of subdirs 150 # Take care of subdirs
124 for x in $(autotools_get_subdirs); do 151 for x in $(autotools_get_subdirs); do
125 if [[ -d ${x} ]] ; then 152 if [[ -d ${x} ]] ; then
128 popd >/dev/null 155 popd >/dev/null
129 fi 156 fi
130 done 157 done
131 fi 158 fi
132 159
133 auxdir=$(autotools_get_auxdir) 160 local auxdir=$(autotools_get_auxdir)
161 local macdir=$(autotools_get_macrodir)
134 162
135 einfo "Running eautoreconf in '${PWD}' ..." 163 einfo "Running eautoreconf in '${PWD}' ..."
136 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 164 [[ -n ${auxdir}${macdir} ]] && mkdir -p ${auxdir} ${macdir}
137 eaclocal 165 eaclocal
166 if grep -q '^AM_GNU_GETTEXT_VERSION' configure.?? ; then
167 eautopoint --force
168 fi
138 [[ ${CHOST} == *-darwin* ]] && g=g 169 [[ ${CHOST} == *-darwin* ]] && g=g
139 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then 170 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
140 _elibtoolize --copy --force --install 171 _elibtoolize --copy --force --install
141 else 172 else
142 _elibtoolize --copy --force 173 _elibtoolize --copy --force
143 fi 174 fi
144 eautoconf 175 eautoconf
145 eautoheader 176 eautoheader
146 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 177 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
147 178
148 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 179 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
149 180
150 # Call it here to prevent failures due to elibtoolize called _before_ 181 # Call it here to prevent failures due to elibtoolize called _before_
151 # eautoreconf. We set $S because elibtoolize runs on that #265319 182 # eautoreconf. We set $S because elibtoolize runs on that #265319
189# without e prefix. 220# without e prefix.
190# They also force installing the support files for safety. 221# They also force installing the support files for safety.
191# Respects AT_M4DIR for additional directories to search for macro's. 222# Respects AT_M4DIR for additional directories to search for macro's.
192eaclocal() { 223eaclocal() {
193 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 224 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
194 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags) 225 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
195} 226}
196 227
197# @FUNCTION: _elibtoolize 228# @FUNCTION: _elibtoolize
198# @DESCRIPTION: 229# @DESCRIPTION:
199# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from 230# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
218# @DESCRIPTION: 249# @DESCRIPTION:
219# Runs autoheader. 250# Runs autoheader.
220eautoheader() { 251eautoheader() {
221 # Check if we should run autoheader 252 # Check if we should run autoheader
222 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 253 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
223 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@" 254 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
224} 255}
225 256
226# @FUNCTION: eautoconf 257# @FUNCTION: eautoconf
227# @DESCRIPTION: 258# @DESCRIPTION:
228# Runs autoconf. 259# Runs autoconf.
232 eerror "No configure.{ac,in} present in '${PWD}'!" 263 eerror "No configure.{ac,in} present in '${PWD}'!"
233 echo 264 echo
234 die "No configure.{ac,in} present!" 265 die "No configure.{ac,in} present!"
235 fi 266 fi
236 267
237 autotools_run_tool autoconf $(autotools_m4dir_include) "$@" 268 autotools_run_tool --at-m4flags autoconf "$@"
238} 269}
239 270
240# @FUNCTION: eautomake 271# @FUNCTION: eautomake
241# @DESCRIPTION: 272# @DESCRIPTION:
242# Runs automake. 273# Runs automake.
244 local extra_opts 275 local extra_opts
245 local makefile_name 276 local makefile_name
246 277
247 # Run automake if: 278 # Run automake if:
248 # - a Makefile.am type file exists 279 # - a Makefile.am type file exists
249 # - a Makefile.in type file exists and the configure
250 # script is using the AM_INIT_AUTOMAKE directive 280 # - the configure script is using the AM_INIT_AUTOMAKE directive
251 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do 281 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
252 [[ -f ${makefile_name} ]] && break 282 [[ -f ${makefile_name} ]] && break
253 done 283 done
254 [[ -z ${makefile_name} ]] && return 0
255 284
256 if [[ ${makefile_name} == *.in ]] ; then 285 if [[ -z ${makefile_name} ]] ; then
257 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then 286 # Really we should just use autotools_check_macro ...
287 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
288 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
258 return 0 289 return 0
259 fi 290 fi
260 291
261 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then 292 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
262 local used_automake 293 local used_automake
287# Runs autopoint (from the gettext package). 318# Runs autopoint (from the gettext package).
288eautopoint() { 319eautopoint() {
289 autotools_run_tool autopoint "$@" 320 autotools_run_tool autopoint "$@"
290} 321}
291 322
323# @FUNCTION: config_rpath_update
324# @USAGE: [destination]
325# @DESCRIPTION:
326# Some packages utilize the config.rpath helper script, but don't
327# use gettext directly. So we have to copy it in manually since
328# we can't let `autopoint` do it for us.
329config_rpath_update() {
330 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
331
332 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
333 [[ $# -eq 0 ]] && return 0
334
335 einfo "Updating all config.rpath files"
336 for dst in "$@" ; do
337 einfo " ${dst}"
338 cp "${src}" "${dst}" || die
339 done
340}
341
292# Internal function to run an autotools' tool 342# Internal function to run an autotools' tool
293autotools_env_setup() { 343autotools_env_setup() {
294 # We do the latest → version switch here because it solves 344 # We do the "latest" → version switch here because it solves
295 # possible order problems, see bug #270010 as an example. 345 # possible order problems, see bug #270010 as an example.
296 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 346 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
297 local pv 347 local pv
298 for pv in ${_LATEST_AUTOMAKE} ; do 348 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
299 # has_version respects ROOT, but in this case, we don't want it to, 349 # has_version respects ROOT, but in this case, we don't want it to,
300 # thus "ROOT=/" prefix: 350 # thus "ROOT=/" prefix:
301 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv" 351 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
302 done 352 done
303 [[ ${WANT_AUTOMAKE} == "latest" ]] && \ 353 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
304 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}" 354 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
305 fi 355 fi
306 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5 356 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
307} 357}
308autotools_run_tool() { 358autotools_run_tool() {
359 # Process our own internal flags first
360 local autofail=true m4flags=false
361 while [[ -n $1 ]] ; do
362 case $1 in
363 --at-no-fail) autofail=false;;
364 --at-m4flags) m4flags=true;;
365 # whatever is left goes to the actual tool
366 *) break;;
367 esac
368 shift
369 done
370
309 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then 371 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
310 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase" 372 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
311 fi 373 fi
312 374
313 autotools_env_setup 375 autotools_env_setup
322 [[ -e ${STDERR_TARGET} ]] || break 384 [[ -e ${STDERR_TARGET} ]] || break
323 : $(( i++ )) 385 : $(( i++ ))
324 done 386 done
325 fi 387 fi
326 388
389 if ${m4flags} ; then
390 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
391 fi
392
327 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}" 393 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
328 394
329 ebegin "Running $@" 395 ebegin "Running $@"
330 "$@" >> "${STDERR_TARGET}" 2>&1 396 "$@" >> "${STDERR_TARGET}" 2>&1
331 eend $? 397 if ! eend $? && ${autofail} ; then
332
333 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
334 echo 398 echo
335 eerror "Failed Running $1 !" 399 eerror "Failed Running $1 !"
336 eerror 400 eerror
337 eerror "Include in your bugreport the contents of:" 401 eerror "Include in your bugreport the contents of:"
338 eerror 402 eerror
367} 431}
368 432
369# Internal function to get additional subdirs to configure 433# Internal function to get additional subdirs to configure
370autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; } 434autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
371autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; } 435autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
436autotools_get_macrodir() { autotools_check_macro_val AC_CONFIG_MACRO_DIR ; }
372 437
373autotools_m4dir_include() { 438_autotools_m4dir_include() {
374 [[ -n ${AT_M4DIR} ]] || return
375
376 local include_opts= 439 local x include_opts
377 440
378 for x in ${AT_M4DIR} ; do 441 for x in "$@" ; do
379 case "${x}" in 442 case ${x} in
380 "-I")
381 # We handle it below 443 # We handle it below
382 ;; 444 -I) ;;
383 *) 445 *)
384 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist" 446 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
385 include_opts="${include_opts} -I ${x}" 447 include_opts+=" -I ${x}"
386 ;; 448 ;;
387 esac 449 esac
388 done 450 done
389 451
390 echo $include_opts 452 echo ${include_opts}
391} 453}
454autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
455autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
392 456
393fi 457fi

Legend:
Removed from v.1.112  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.20